//: concurrency/ResponsiveUI.java
// Reaktywno interfejsu uytkownika.
// {RunByHand}

class UnresponsiveUI {
  private volatile double d = 1;
  public UnresponsiveUI() throws Exception {
    while(d > 0)
      d = d + (Math.PI + Math.E) / d;
    System.in.read(); // Sterowanie nigdy tu nie dotrze
  }
}

public class ResponsiveUI extends Thread {
  private static volatile double d = 1;
  public ResponsiveUI() {
    setDaemon(true);
    start();
  }
  public void run() {
    while(true) {
      d = d + (Math.PI + Math.E) / d;
    }
  }
  public static void main(String[] args) throws Exception {
    //! new UnresponsiveUI(); // Trzeba "ubi" ten proces
    new ResponsiveUI();
    System.in.read();
    System.out.println(d); // Pokazuje postp operacji
  }
} ///:~
